<?php

// How to control the app
$action = !empty($_REQUEST['action']) ? $_REQUEST['action'] : '';

function plastic_sidebar($user_id) {

foreach($_POST as $key => $val) {
	$_POST[$key] = stripslashes($val);
}

global $wpdb;

$sidebar_format_string = get_option('plastic_tunes_sidebar_format_string');
$sidebar_count = get_option('plastic_tunes_sidebar_count');
$sidebar_outer_tag = get_option('plastic_tunes_sidebar_outer_tag');
$format_date = get_option('plastic_tunes_format_date');
$sidebar_title = get_option('plastic_tunes_sidebar_title');
$togglesidebar_if = get_option('plastic_tunes_togglesidebar_if');
$togglesidebar_manual = get_option('plastic_tunes_togglesidebar_manual');
$sidegoogle = get_option('plastic_tunes_sidegoogle');
$widgettitle = get_option('plastic_tunes_widget_title');
$playerstate = get_option('plastic_tunes_player_state');

$min_user_level = get_option('plastic_tunes_min_user_level');
$db_timezone_offset = get_option('plastic_tunes_db_timezone_offset');
$srv_timezone_offset = get_option('plastic_tunes_srv_timezone_offset');
$user_info = get_userdata( $user_id );

if ( !$plastic_tunes_startrow ) $plastic_tunes_startrow = 0;

/*if manual hiding is on, end of story*/
if ($togglesidebar_manual == 'Y') return;
/* if player is off and "hiding when player is off" is on, end of story*/
elseif ( ($playerstate  == '0') && ($togglesidebar_if == 'Y') ) return;
/* otherwise the last record will be retrieved and the sidebar built */
else {
		$variables = array('%artist%','%album%','%title%','%year%','%rating%','%created%','%time_ago%','%genre%','%track%','%duration%');	
		
		$songlist = $wpdb->get_results('SELECT artist AS artist, album AS album, title AS title, year AS year, rating AS rating, 
		DATE_FORMAT( date_add( created , INTERVAL '. $db_timezone_offset .' HOUR) , "'. $format_date .'") AS created_date, UNIX_TIMESTAMP(created) AS time_stamp,
		genre AS genre, track AS track, duration AS duration		
		FROM '.$wpdb->prefix.'plastic_tunes
		WHERE user_id = '.$user_id.'
		ORDER BY created DESC
		LIMIT '.$sidebar_count. '
		');	
		
		if( $songlist) {		
			$user = get_userdata($user_id);
			
			//if a title is specified in the options...
			if ($sidebar_title != '') {
				//...and the title of the widget is empty, we build the title
				if ($widgettitle == '')	echo str_replace('%name%', $user->display_name, $sidebar_title);
				}
			//if no title is specified in the options, you build the tile here
			else {			
				/* ################### Edit the title of your sidebar code here #####################*/				
				/*In this example, the title changes according to the state of the player
				Don't mind the formatting elements, they're for the author of the plugin*/
				if (  $playerstate == '0' ) {
					echo '<span class="sidehead" style="white-space: nowrap;">// last thing I heard</span>&nbsp;<span class="sidebody">&nbsp;(<a href="http://www.italyisfalling.com/music" title="music I listened to recently">...</a>)</span><br/><br/><ul class="sidebody">';
				}
				else {
					echo '<span class="sidehead"style="white-space: nowrap;">// listening to</span>
					<span class="sidebody">&nbsp;(<a href="http://www.italyisfalling.com/music" 
					title="music I listened to recently">...</a>)</span><br/><br/><ul class="sidebody">';
				}			
				/* ################### END Edit sidebar title #####################*/
			}
			
			$songlist_count = 1;
			
				foreach($songlist as $song) {			
				
					//if a format string has been specified
					if ($sidebar_format_string != '') {	
					
						//if google links are not requested
						if ($sidegoogle != 'Y') {	
							$artist = $song->artist;
							$album = $song->album;
							$title = $song->title;
							$genre = $song->genre;
							$track = $song->track;
						}						
						//if google links are requested
						else {
							$artist = '<a href="http://www.google.com/search?q=%22' . str_replace('&', '%26',$song->artist) . '%22">' . 
							$song->artist . '</a>';
							$album = '<a href="http://www.google.com/search?q=%22' . str_replace('&', '%26', $song->artist) . '%22 '. 
							str_replace('&', '%26', $song->album) . '">'. $song->album . '</a>';
							$title = $song->title;	
						}						
						//calculating time spans
						$dursec = intval(substr($song->duration,0,2) * 60 *60) + intval(substr($song->duration,3,2) *60) + intval(substr($song->duration,6,2));				
						$UNIXsongstamp = $song->time_stamp; // + ($srv_timezone_offset * 60 * 60 )
						$UNIXsum = $dursec + $UNIXsongstamp;
						$UNIXnow = time()+ ($srv_timezone_offset * 60 * 60 );						
						if ($UNIXnow <= $UNIXsum ) $timestring1 = 'Playing now';
						else $timestring1 = $song->created_date;						
						if ($UNIXnow <= $UNIXsum ) $timestring2 = 'Playing now';
						else $timestring2 = 'Played ' . jal_time_since( $song->time_stamp ) . ' ago';
						
						$replacements = array($artist,$album,$title,$song->year,$song->rating,$timestring1,$timestring2,$genre,$track,$duration);
						echo str_replace($variables, $replacements, $sidebar_format_string);
									
					}
					
					//if no format string has been specified
					else {
					
						/* ################### Edit your sidebar code here #####################*/			
						
						/*in this example, links appear for the title of the song when no album is present,
						 and a comma precedes year or album only if values are present*/
						
						$artist = $song->artist;
						$album = $song->album;
						$title = $song->title;
						$genre = $song->genre;
						$track = $song->track;
						
						/*conditional for a album title beginning with '(misc'
						 (this is special for the author of the plugin, don't bother.*/
						if (strstr($song->album, '(misc')) $song->album = '';
							
						//if google links are not requested
						if ($sidegoogle != 'Y') {	
						
							//conditional album
							if ($song->album == '')	$fromalbum = '';
							else $fromalbum = ', '. $album;
							
							//conditional artist
							$theartist = $artist;
						}
						
						//if google links are requested
						else {
						
							// conditional album
							if ($song->album == '')	{
								$fromalbum = '';
								$titlelink = '<a href="http://www.google.com/search?q=%22' . str_replace('&', '%26', $artist) . '%22 %22' 
								. str_replace('&', '%26', $title) . '%22"><em>'. $title . '</em></a>';
							}							
							else {							
								$fromalbum = ', <a href="http://www.google.com/search?q=%22' . str_replace('&', '%26', $artist) . '%22 '
								. str_replace('&', '%26', $album) . '">'. $album . '</a>';
								$titlelink =  $title;
							}
							
							// conditional artist							
								$theartist = '<a href="http://www.google.com/search?q=%22' . str_replace('&', '%26', $artist) . '%22">'. $artist . '</a>';
						}
						
						// confitional year
						if ($song->year != '') $yearstring = ', ' . $song->year;
						else $yearstring = '';
						
						echo '<li>' . $theartist . ', <em>' . $titlelink . '</em>'. $yearstring . $fromalbum .'</li>';
					
						/* ################### END Edit sidebar code #####################*/	
				
					}	
				
				}
				
				echo $sidebar_outer_tag;
			}
	}
}

/*this is called from the template of a dedicated page, and will generate 
a table with all the entries of the music items added to the database*/
function plastic_table($user_id) {

	foreach($_REQUEST as $key => $val) {
		${"plastic_tunes_".$key} = stripslashes($val);
	}
	
	global $wpdb;
		
	/* this is a trick to allow the user_id variable coming via tag 
	to be considered as the variable coming via URI */
	if ( $user_id ) $plastic_tunes_user_id = $user_id;
	
	//check if there is a user_id value coming in
	if ( $plastic_tunes_user_id ) {
		$user_id = $plastic_tunes_user_id;
		
		$index_count = get_option('plastic_tunes_index_count');
		$index_title = get_option('plastic_tunes_index_title');
		$indexgoogle = get_option('plastic_tunes_indexgoogle');
		$tableclass = get_option('plastic_tunes_tableclass');
		$skiprepeats = get_option('plastic_tunes_skip_repeats');
		
		$sql_limit = $index_count + 1;	
		$min_user_level = get_option('plastic_tunes_min_user_level');
		$db_timezone_offset = get_option('plastic_tunes_db_timezone_offset');
		$srv_timezone_offset = get_option('plastic_tunes_srv_timezone_offset');
		$format_date = get_option('plastic_tunes_format_date');
		
		$user_info = get_userdata( $user_id );
		$user_name = $user_info->display_name;
		$min_user_level = get_option('plastic_tunes_min_user_level');
		$userlist_text = get_option('plastic_tunes_userlist_text');
		
		$showtitle = get_option('plastic_tunes_showtitle');
		$showartist = get_option('plastic_tunes_showartist');
		$showalbum = get_option('plastic_tunes_showalbum');
		$showyear = get_option('plastic_tunes_showyear');
		$showgenre = get_option('plastic_tunes_showgenre');
		$showtrack = get_option('plastic_tunes_showtrack');
		$showratings = get_option('plastic_tunes_showratings');
		$showdate = get_option('plastic_tunes_showdate');
		$showlastedtime = get_option('plastic_tunes_showlastedtime');
		$showduration = get_option('plastic_tunes_showduration');
		$shownav = get_option('plastic_tunes_shownav');
		
		$colcount = 0;
		if ($showartist == 'Y' || $showtitle == 'Y' ) $colcount++;
		if ($showalbum == 'Y') $colcount++;
		if ($showratings == 'Y') $colcount++;
		if ($showdate == 'Y' || $showlastedtime == 'Y') $colcount++;
		if ($showyear == 'Y' || $showgenre == 'Y' ) $colcount++;
		if ($showtrack == 'Y') $colcount++;
		if ($showduration == 'Y') $colcount++;
		
		$text_length = 30;	
		if ( !$plastic_tunes_startrow ) $plastic_tunes_startrow = 0;
		
		$songlist = $wpdb->get_results('SELECT artist AS artist, album AS album, title AS title, year AS year, rating AS rating, 
		DATE_FORMAT( date_add( created , INTERVAL '. $db_timezone_offset .' HOUR) , "'. $format_date .'") AS created_date, UNIX_TIMESTAMP(created) AS time_stamp,
		genre AS genre, track AS track,	duration AS duration	
		FROM '.$wpdb->prefix.'plastic_tunes
		WHERE user_id = '.$user_id.'
		ORDER BY created DESC
		LIMIT '. $plastic_tunes_startrow .', '. $sql_limit .'');
		
		echo '<LINK REL=StyleSheet HREF="'. $tableclass .'" TYPE="text/css">';
		
		//if there's any data we output the table
		if ($songlist) {
		
			//first the title
			$output = str_replace('%name%', $user_name, $index_title);
			
			//then the table headers
			$output.= '<br/><table class="plastic_table_class"><tr class="plastic_header_class">';
			if ( $showartist == "Y" || $showtitle == "Y" ) {
				$output.= '<th class="plastic_th_class">';
				if ( $showartist == "Y" && $showtitle == "Y" ) $output.= 'Title &amp; Artist';
				elseif ( $showartist == "Y" ) $output.= 'Artist';
				else $output.= 'Title';
				$output.= '</th>';
			}
			if ( $showalbum == "Y" ) $output.= '<th class="plastic_th_class">Album</th>';
			if ( $showratings == "Y" ) $output.= '<th class="plastic_th_class" align="center">Rating</th>';
			if ( $showdate == "Y" || $showlastedtime == "Y" ) $output.= '<th class="plastic_th_class">Date & Time</th>';
			if ( $showduration == "Y" ) $output.= '<th class="plastic_th_class">Duration</th>';
			if ( $showgenre == "Y" || $showyear == "Y" ) {
				$output.= '<th class="plastic_th_class">';
				if ( $showgenre == "Y" && $showyear == "Y" ) $output.= 'Genre & Year';
				elseif ( $showgenre == "Y" ) $output.= 'Genre';
				else $output.= 'Year';
				$output.= '</th>';
			}
			if ( $showtrack == "Y" ) $output.= '<th class="plastic_th_class">Track</th>';
			$output.= '</tr>';
		
			//then the records
			$songlist_count = 1;			
			foreach($songlist as $song) {			
	
				//check for duplicates if requested	
				$match = 0;	
				if ($skiprepeats = 'Y') {
				
					$var1 = $song->artist . ' ' . $song->title . ' ' . $song->album ;			
					/*$get_different = $songlist;*/
					$get_different = $wpdb->get_results('SELECT artist AS artist, album AS album, title AS title
					FROM '.$wpdb->prefix.'plastic_tunes
					WHERE user_id = '.$user_id.'
					ORDER BY created DESC');
							
					$different_count = 1;			
					foreach ($get_different as $different) {
						if ( $different_count < $songlist_count ) {
							$var2 = $different->artist . ' ' . $different->title . ' ' . $different->album ;				
							if 	($var1 == $var2) {$match = 1;}
							}
						$different_count++;
					}
					
				}
				if ($match == 1) {		
					$songlist_count++;		
					continue;	
				}			

			
				$genre = $song->genre;
				$track = $song->track;
				$year = $song->year;
			
				//shortening too long title lines
				if ( strlen( $song->title ) > $text_length ) {
					$html_title_attrib = ' title="'. $song->title .'"';
					$shorttitle = substr( $song->title , 0 , $text_length ) . "...";
				}
				else {
					$html_title_attrib = '';
					$shorttitle = $song->title;
				}
				
				/*conditional for a album title beginning with '(misc'
				(this is special for the author of the plugin, don't bother, comment it out*/
				if (strstr($song->album, '(misc')) $song->album = '';
			
				//if google links are not requested
				if ($indexgoogle != 'Y') {	
					$artist = $song->artist;
					$album = $song->album;
					$title = $shorttitle;
				}
				
				//if google links are requested
				else {
					$artist = '<a href="http://www.google.com/search?q=%22' . str_replace('&', '%26',$song->artist) . '%22">' . 
					$song->artist . '</a>';
					$album = '<a href="http://www.google.com/search?q=%22' . str_replace('&', '%26', $song->artist) . '%22 '. 
					str_replace('&', '%26', $song->album) . '">'. $song->album . '</a>';
					$title = $song->title;	
				}

				//calculating time spans
				$dursec = intval(substr($song->duration,0,2) * 60 *60) + intval(substr($song->duration,3,2) *60) + intval(substr($song->duration,6,2));				
				$UNIXsongstamp = $song->time_stamp; // + ($srv_timezone_offset * 60 * 60 )
				$UNIXsum = $dursec + $UNIXsongstamp;
				$UNIXnow = time()+ ($srv_timezone_offset * 60 * 60 );		
				if ($UNIXnow <= $UNIXsum ) $createdtime = 'Playing now';
				else $createdtime = $song->created_date;		
				if ($UNIXnow <= $UNIXsum ) $lastedtime = 'Playing now';
				else $lastedtime = 'Played ' . jal_time_since( $song->time_stamp ) . ' ago';
				
	
				//preparing the alternate styles for the records and outputting the line
				if ( $songlist_count % 2 == 0 ) $tr_class_alt = "plastic_odd_record";
				else $tr_class_alt = "plastic_even_record";		
				$output.= '<tr class="'.$tr_class_alt.'">';
				
				//conditional artist and title
				if ( $showtitle == 'Y' || $showartist == 'Y' ) {
					$output.= '<td valign="top" class="plastic_td_class" '. $html_title_attrib .'>';
					if ( $showtitle == 'Y' ) $output.= '<em> '. $title .' </em>';
					if ( $showartist == 'Y' ) $output.= '<strong> '. $artist .' </strong>';
					$output.= '</td>';
				}
				
				//conditional album
				if ( $showalbum == 'Y' ) $output.= '<td valign="top" class="plastic_td_class">'.$album.'</td>';
		
				//conditional rating
				if ( $showratings == 'Y' ) {
					if ( $song->rating == 0 )$song_rating = '-'; 
					else $song_rating = $song->rating;
					$output.= '<td valign="top" class="plastic_td_class" align="center">'. $song_rating .'</td>';
				}
				
				// conditional date & time spans
				if ( $showdate == 'Y' ||  $showlastedtime == 'Y' ) {				
					$output.= '<td valign="top" class="plastic_td_class">';
					if ( $showdate == 'Y') $output.= $createdtime. '. ';
					if ( $showlastedtime == 'Y') $output.= $lastedtime;
					$output.= '</td>';
				}
				
				//conditional year & genre
				if ( $showyear == 'Y' || $showgenre == 'Y' ) {
					$output.= '<td valign="top" class="plastic_td_class" '. $html_title_attrib .'>';
					if ( $showgenre == 'Y' ) $output.= '<div>'. $genre .'</div>';
					if ( $showyear == 'Y' ) $output.= '<div>'. $year .'</div>';
					$output.= '</td>';
				}
				
				//conditional track number
				if ( $showtrack == 'Y' ) $output.= '<td valign="top" class="plastic_td_class">'. $track  .'</td>';
				
				//conditional duration
				if ( $showduration == 'Y' ) $output.= '<td valign="top" class="plastic_td_class">'. $duration  .'</td>';
				
				//and close the line
				$output.= '</tr>';
		
				if ( $songlist_count == $index_count ) break;
				else $songlist_count++;
			}
			
			//generating the navigator
			if ( $shownav == "Y") {
			
					$plastic_tunes_startrow_plus = $plastic_tunes_startrow + $index_count;
					$plastic_tunes_startrow_minus = $plastic_tunes_startrow - $index_count;
				
					$output.= '<tr class="plastic_even_record">';
					$output.= '<td class="plastic_td_class" colspan="'. $colcount .'" align="center">';					
					$thispage = $_SERVER["REQUEST_URI"];		
					
					/* first I check if a "&startrow" variable is present in the URI, in which case
					i have to strip it from the URI otherwise, because of the way the output is conceived below,
					in the next page I'd have two "&startrow=&startrow=" in the same URI. */										
					if (stristr($thispage,"&startrow") != FALSE) {
						$novars = str_replace(stristr($thispage,"&startrow"), "", $thispage);
						$connect = "&startrow=";
					}
					
					/*  then there's the case where a "&startrow" is NOT present in the URI */					
					else {
					
						/* if any other "&" is present in the URI that is not "&startrow", 
						it is safe to use "&" to connect "startrow" */						
						if (stristr($thispage,"&") != FALSE ) {
						$novars = $thispage;
						$connect = "&startrow=";
						}
									
						/*if no other "&" is present*/						
						else {
						
							/* in case that a "?startrow" is present (this could happen, with non-default permalinks, 
							and with a "user_id" variable sent in via the tag instead than via the URI)
							I will strip it off the URI and connect the next "startrow" with a "?" */							
							if (stristr($thispage,"?startrow") != FALSE) {
								$novars = str_replace(stristr($thispage,"?startrow"), "", $thispage);
								$connect = "?startrow=";
							}
						
							/* and if no "?startrow" is present */							
							else {
							
								/* if there are any "?" left in the URI, like default permalinks or anything else,
								it is safe to use "&startrow"  */								
								if (stristr($thispage,"?") != FALSE ) {
								$novars = $thispage;
								$connect = "&startrow=";
								}
								
								/* finally, if no "?" is present, I connect "startrow" with a "?" */								
								else {
								$novars = $thispage;
								$connect = "?startrow=";
								}
							}
						}
					}		
			
				$output.= '<ol style="list-style-type: none;margin: 0;padding: 0"><li style="list-style-type: none;float: left;width: 10em;text-indent: 0px;">';
				
				if ( $songlist_count == $index_count ) {				
					$output.= '<br/><a href="'. $novars . $connect . $plastic_tunes_startrow_plus .'">&#8249; previous '. $index_count . '</a><br/></li>';
					if ( $plastic_tunes_startrow > 1 ) {
						$output.= '<li style="list-style-type: none;float:right;width: 10em;text-indent: 0px;">
						<br/><a href="'. $novars . $connect . $plastic_tunes_startrow_minus .'">next '. $index_count . ' &#8250;</a><br/></li>';
					}				
				} 						
		
				else {			
				if ($plastic_tunes_startrow > $songlist_count) {
					$output.= '<li style="float:right;width: 10em;">
					<br/><a href="'. $novars . $connect . $plastic_tunes_startrow_minus .'">next '. $index_count . ' &#8250;</a><br/></li>';
					}
				}
				
				$output.= '</ul>';
				$output.= '</td></tr>';	
			}
			
			$output.= '</table>';
		}
		
		
		echo $output;
	}
	
	//if no $user_id generates the list of users
	else  {	
	$plastic_tunes_users = $wpdb->get_results('
	SELECT u.id as id, u.display_name as display_name, count(*) as pcount
	FROM '.$wpdb->prefix.'plastic_tunes m, '.$wpdb->prefix.'users u
	WHERE u.id = m.user_id
	GROUP BY u.id, u.display_name
	ORDER BY pcount DESC');

	if ( $plastic_tunes_users ) {
	
		$thispage = $_SERVER["REQUEST_URI"];
		
		/*check if there'already a "?" in the URI*/
		if (stristr($thispage,"?") != FALSE) $connect_id = "&user_id=";
		else  $connect_id = "?user_id=";
	
		$output = '<h2>'. $userlist_text .'</h2><ul>';
		foreach( $plastic_tunes_users as $puser) {
			$output .= '<li><a href="'. $_SERVER["REQUEST_URI"]. $connect_id . $puser->id .'">'. $puser->display_name .'</a> ('. $puser->pcount .' music items)</li>';
		}
		
	$output .= '</ul>';
	echo $output;

	}
	
	}

}


// Works out the time since the entry post, takes a an argument in unix time (seconds)
function jal_time_since($original) {
    // array of time period chunks
    $chunks = array(
        array(60 * 60 * 24 * 365 , 'year'),
        array(60 * 60 * 24 * 30 , 'month'),
        array(60 * 60 * 24 * 7, 'week'),
        array(60 * 60 * 24 , 'day'),
        array(60 * 60 , 'hour'),
        array(60 , 'minute'),
    );
    $original = $original - 10; // Shaves a second, eliminates a bug where $time and $original match.
    $today = time(); /* Current unix time  */
    $since = $today - $original;
    
    // $j saves performing the count function each time around the loop
    for ($i = 0, $j = count($chunks); $i < $j; $i++) {
        
        $seconds = $chunks[$i][0];
        $name = $chunks[$i][1];
        
        // finding the biggest chunk (if the chunk fits, break)
        if (($count = floor($since / $seconds)) != 0) {
            break;
        }
    }
    
    $print = ($count == 1) ? '1 '.$name : "$count {$name}s";
    
    if ($i + 1 < $j) {
        // now getting the second item
        $seconds2 = $chunks[$i + 1][0];
        $name2 = $chunks[$i + 1][1];
        
        // add second item if it's greater than 0
        if (($count2 = floor(($since - ($seconds * $count)) / $seconds2)) != 0) {
            $print .= ($count2 == 1) ? ', 1 '.$name2 : ", $count2 {$name2}s";
        }
    }
    return $print;
}


//paypal and links
function plastic_block() {
	
	echo '<div class="wrap" style="margin-top:10px; padding:6px; margin:auto; text-align:center; >
            <ul>
            <li style="line-height:1em;display:inline;list-style:none;letter-spacing:0.5%;"><a href="http://www.italyisfalling.com/plastic-tunes">Plugin\'s Homepage</a> | </li>
            <!--<li style="line-height:1em;display:inline;list-style:none;letter-spacing:0.5%;">Donate | </li>-->
            <li style="line-height:1em;display:inline;list-style:none;letter-spacing:0.5%;"><a href="http://www.italyisfalling.com/coding">Other plugins</a></li>
            </ul>
    </div>';
}


?>